#version 150

// vertexPosition was bound to attribute index 0 and vertexColor was bound to attribute index 1
in vec3 vertexPosition;
in vec3 vertexNormal;
in vec4 vertexColor;
in vec2 vertexTextureUV;
 
// Our outputs the next shader (fragment) in the chain
out vec3 fragmentNormal;
out vec4 fragmentColor;
out vec2 fragmentTextureUV;

// diffuseTexture is a 2D texture sampler for diffuse texture.
uniform sampler2D diffuseTexture;
uniform mat4 mvpMatrix;
uniform mat4 modelViewMatrix;

void main(void)
{
    gl_Position = vec4(vertexPosition, 1.0) * mvpMatrix;

    fragmentNormal = vec3(normalize(vec4(vertexNormal, 0.0) * modelViewMatrix));

    //float nDotL = max(dot(fragmentNormal, vec3(sunLightDirection)), 0.0);
    //fragmentColor = vec4(nDotL * vec3(vertexColor), 1.0);

    vec2 textureUV = vec2(vertexColor.r, 0.0);
    fragmentColor = texture(diffuseTexture, textureUV);
    fragmentTextureUV = vertexTextureUV;
}

//--- Old Implementation of BasicObjectVertexShader ---
//
//	vec3 lightDirection = normalize(vec3(gl_LightSource[0].position));
//	vec3 normal = normalize(gl_NormalMatrix * gl_Normal); //Need to transform normal into eye space
//	float nDotL = max(dot(normal, lightDirection), 0.0);
//	
//	vec4 pos = gl_Vertex;
//	//pos.x += magicMotion * 5;
//
//	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
//	gl_FrontColor = nDotL * gl_Color + gl_LightModel.ambient; //gl_FrontMaterial.diffuse;
//
//	//gl_FrontColor.r += magicMotion;
//	
//	//gl_Position = ftransform(); //gl_ProjectionMatrix * gl_ModelViewMatrix * pos;
//	gl_Position = gl_ProjectionMatrix * gl_ModelViewMatrix * pos;
